'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regeneratorRuntime = require('regenerator-runtime');

var _regeneratorRuntime2 = _interopRequireDefault(_regeneratorRuntime);

var _bivrostFetchAdapter = require('bivrost-fetch-adapter');

var _bivrostFetchAdapter2 = _interopRequireDefault(_bivrostFetchAdapter);

var _setup = require('./setup');

var _setup2 = _interopRequireDefault(_setup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function processResponse(response) {
  var headers = response && response.headers;

  if (headers) {
    var contentType = headers.get('content-type');

    if (contentType && contentType.indexOf('application/json') !== -1) {
      return response.json();
    } else if (contentType && contentType.indexOf('image') !== -1) {
      return response.blob();
    } else {
      return response.text();
    }
  }

  return response;
}

exports.default = (0, _setup2.default)({
  headers: {
    'Content-Type': 'application/json'
  },
  mode: 'cors',
  adapter: _bivrostFetchAdapter2.default,
  interceptors: {
    error: function () {
      var _ref = _asyncToGenerator(_regeneratorRuntime2.default.mark(function _callee(_error) {
        return _regeneratorRuntime2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return processResponse(_error);

              case 2:
                return _context.abrupt('return', _context.sent);

              case 3:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, undefined);
      }));

      return function error(_x) {
        return _ref.apply(this, arguments);
      };
    }(),
    response: function () {
      var _ref2 = _asyncToGenerator(_regeneratorRuntime2.default.mark(function _callee2(_response) {
        return _regeneratorRuntime2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return processResponse(_response);

              case 2:
                return _context2.abrupt('return', _context2.sent);

              case 3:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, undefined);
      }));

      return function response(_x2) {
        return _ref2.apply(this, arguments);
      };
    }()
  }
});